import { VaultFormatA } from "../VaultFormatA.js";
/**
 * Flattener class for flattening archive history sets
 */
export declare class Flattener {
    /**
     * Minimum history lines before flattening can occur
     * @static
     * @memberof Flattener
     */
    static FLATTENING_MIN_LINES: number;
    /**
     * Number of lines to preserve (most recent)
     * @static
     * @memberof Flattener
     */
    static PRESERVE_LINES: number;
    format: VaultFormatA;
    constructor(format: VaultFormatA);
    /**
     * Check if the dataset can be flattened
     * @returns True if it can be flattened
     * @memberof Flattener
     */
    canBeFlattened(): boolean;
    /**
     * Flatten a dataset
     * @param force Force flattening even if it is detected to be unnecessary
     * @returns True if flattening occurred, false otherwise
     * @memberof Flattener
     */
    flatten(force?: boolean): boolean;
}
