/**
 * Get the current signature
 * @returns The signature
 */
export declare function getSignature(): string;
/**
 * Detect if a string has a valid signature
 * @param text The text to check
 * @returns True if a valid signature is detected
 */
export declare function hasValidSignature(text: string): boolean;
/**
 * Sign some text
 * @param text The text to sign
 * @returns The signed text
 */
export declare function sign(text: string): string;
/**
 * Strip the signature from some text
 * @param text The text to strip the signature from
 * @returns The text with the signature removed
 */
export declare function stripSignature(text: string): string;
/**
 * Check if vault contents are in encrypted form
 * @param contents The vault contents
 * @returns True if encrypted, false otherwise
 */
export declare function vaultContentsEncrypted(contents: string): boolean;
