import { VaultFormatA } from "./VaultFormatA.js";
import { VaultFormatB } from "./VaultFormatB.js";
import { hasValidSignature as isFormatBSigned } from "./formatB/signing.js";
import { VaultFormatID } from "../types.js";
const DEFAULT_FORMAT = VaultFormatB;
let __defaultFormat = DEFAULT_FORMAT;
export function detectFormat(encryptedContent) {
    if (isFormatBSigned(encryptedContent)) {
        return VaultFormatB;
    }
    return VaultFormatA;
}
export function getDefaultFormat() {
    return __defaultFormat;
}
export function getFormatForID(id) {
    if (id === VaultFormatID.B) {
        return VaultFormatB;
    }
    return VaultFormatA;
}
export function setDefaultFormat(Format = null) {
    __defaultFormat = Format || DEFAULT_FORMAT;
}
