import { getSharedAppEnv } from "../env/appEnv.js";
import { getCredentials } from "../credentials/channel.js";
export const ATTACHMENT_EXT = "bcatt";
export function decryptAttachment(buff, credentials) {
    const { masterPassword } = getCredentials(credentials.id);
    const decrypt = getSharedAppEnv().getProperty("crypto/v2/decryptBuffer");
    return decrypt(buff, masterPassword);
}
export function encryptAttachment(buff, credentials) {
    const { masterPassword } = getCredentials(credentials.id);
    const encrypt = getSharedAppEnv().getProperty("crypto/v2/encryptBuffer");
    return encrypt(buff, masterPassword);
}
export function getBufferSize(buff) {
    if (typeof buff.byteLength !== "undefined") {
        return buff.byteLength;
    }
    return buff.length;
}
