export interface AppEnv {
    getProperty: AppEnvGetPropertyMethod;
    hasProperty: AppEnvHasPropertyMethod;
    setProperties: AppEnvSetPropertiesMethod;
    setProperty: AppEnvSetPropertyMethod;
}
interface AppEnvGetPropertyMethod {
    (name: string, options?: AppEnvGetPropertyOptions): any;
}
interface AppEnvHasPropertyMethod {
    (name: string): boolean;
}
interface AppEnvSetPropertiesMethod {
    (properties: {
        [key: string]: any;
    }): void;
}
interface AppEnvSetPropertyMethod {
    (name: string, value: any): void;
}
export interface AppEnvGetPropertyOptions {
    defaultValue?: any;
    failIfNotExist?: boolean;
}
/**
 * Create a new application environment
 * @returns A new AppEnv instance
 */
export declare function createAppEnv(): AppEnv;
export {};
