/// <reference types="node" />
declare function decryptData(data: string | Buffer, password: string): Promise<string | Buffer>;
declare function encryptData(data: string | Buffer, password: string): Promise<string | Buffer>;
export declare function getCryptoResources(): {
    "crypto/v2/decryptBuffer": typeof decryptData;
    "crypto/v2/encryptBuffer": typeof encryptData;
    "crypto/v1/decryptText": typeof decryptData;
    "crypto/v1/encryptText": typeof encryptData;
    "crypto/v1/randomString": typeof randomString;
    "crypto/v1/setDerivationRounds": typeof setDerivationRounds;
};
declare function randomString(length: number): Promise<string>;
declare function setDerivationRounds(rounds?: number): void;
export {};
