/**
 * Convert base64 to text/buffer
 * @returns A decoded string or buffer
 */
declare function decodeBase64(b64: string, raw?: boolean): string | Uint8Array;
/**
 * Convert bytes to base64
 * @returns A base64-encoded string
 */
declare function encodeBytesToBase64(bytes: Uint8Array): string;
/**
 * Convert text to base64
 * @returns A base64-encoded string
 */
declare function encodeBase64(text: string): string;
export declare function getEncodingResources(): {
    "encoding/v1/base64ToBytes": (input: string) => string | Uint8Array;
    "encoding/v1/base64ToText": typeof decodeBase64;
    "encoding/v1/bytesToBase64": typeof encodeBytesToBase64;
    "encoding/v1/textToBase64": typeof encodeBase64;
};
export {};
