import { EntryPropertyValueType, EntryType } from "../types.js";
export type EntryPropertyTypeIndex = {
    [key in EntryPropertyValueType]: {
        title: string;
        slug: EntryPropertyValueType;
    };
};
export type EntryTypeIndex = {
    [key in EntryType]: {
        title: string;
        slug: EntryType;
    };
};
/**
 * Default entry type
 * @memberof module:Buttercup
 */
export declare const DEFAULT_ENTRY_TYPE = EntryType.Login;
/**
 * Default entry field type
 * @memberof module:Buttercup
 */
export declare const DEFAULT_FIELD_TYPE = EntryPropertyValueType.Text;
/**
 * Entry types collection (all available)
 * @memberof module:Buttercup
 */
export declare const ENTRY_TYPES: EntryTypeIndex;
export declare const FACADE_VERSION = 2;
/**
 * Entry field value types collection (all available)
 * @memberof module:Buttercup
 */
export declare const FIELD_VALUE_TYPES: EntryPropertyTypeIndex;
