import { VaultFormat } from "./VaultFormat.js";
import { Vault } from "../core/Vault.js";
import { Credentials } from "../credentials/Credentials.js";
import { EntryChange, EntryID, FormatBEntry, FormatBGroup, FormatBVault, GroupID, History, PropertyKeyValueObject, VaultFormatID, VaultID } from "../types.js";
export declare class VaultFormatB extends VaultFormat {
    static encodeRaw(rawContent: History, credentials: Credentials): Promise<string>;
    static extractSharesFromHistory(history: History): Object;
    static getFormatID(): VaultFormatID;
    static historiesDiffer(historyA: History, historyB: History): boolean;
    static isEncrypted(contents: string): boolean;
    static parseEncrypted(encryptedContent: string, credentials: Credentials): Promise<History>;
    static vaultFromMergedHistories(base: History, incoming: History): Vault;
    source: FormatBVault;
    constructor(source?: FormatBVault);
    cloneEntry(entry: FormatBEntry, targetGroupID: GroupID): void;
    cloneGroup(group: FormatBGroup, targetGroupID: GroupID): void;
    createEntry(groupID: GroupID, entryID: EntryID): void;
    createGroup(parentID: GroupID, groupID: GroupID): void;
    deleteEntry(entryID: EntryID): void;
    deleteEntryAttribute(entryID: EntryID, attribute: string): void;
    deleteEntryProperty(entryID: EntryID, property: string): void;
    deleteGroup(groupID: GroupID): void;
    deleteGroupAttribute(groupID: GroupID, attribute: string): void;
    deleteVaultAttribute(attribute: string): void;
    erase(): void;
    execute(commandOrCommands: string | Array<string>): void;
    findEntryByID(id: EntryID): FormatBEntry;
    findGroupByID(id: GroupID): FormatBGroup;
    findGroupContainingEntryID(id: EntryID): FormatBGroup;
    findGroupContainingGroupID(id: GroupID): FormatBGroup;
    generateID(): void;
    getAllEntries(parentID?: GroupID): Array<FormatBEntry>;
    getAllGroups(parentID?: GroupID): Array<FormatBGroup>;
    getEntryAttributes(entrySource: FormatBEntry): PropertyKeyValueObject;
    getEntryChanges(entrySource: FormatBEntry): Array<EntryChange>;
    getEntryProperties(entrySource: FormatBEntry): PropertyKeyValueObject;
    getFormat(): typeof VaultFormatB;
    getGroupAttributes(groupSource: FormatBGroup): PropertyKeyValueObject;
    getGroupTitle(groupSource: FormatBGroup): string;
    getHistory(): History;
    getItemID(itemSource: FormatBGroup | FormatBEntry): GroupID | EntryID;
    getItemParentID(itemSource: FormatBGroup | FormatBEntry): GroupID | "0";
    getVaultAttributes(): PropertyKeyValueObject;
    getVaultID(): VaultID;
    initialise(): void;
    moveEntry(entryID: EntryID, groupID: GroupID): void;
    moveGroup(groupID: GroupID, newParentID: GroupID): void;
    optimise(): void;
    prepareOrphansGroup(): FormatBGroup;
    setEntryAttribute(entryID: EntryID, attribute: string, value: string): void;
    setEntryProperty(entryID: EntryID, property: string, value: string): void;
    setGroupAttribute(groupID: GroupID, attribute: string, value: string): void;
    setGroupTitle(groupID: GroupID, title: string): void;
    setVaultAttribute(key: string, value: string): void;
}
