/**
 * Storage Interface (stub only)
 * @see MemoryStorageInterface
 * @memberof module:Buttercup
 */
export declare class StorageInterface {
    /**
     * Get all keys as an array
     * @memberof StorageInterface
     */
    getAllKeys(): Promise<Array<string>>;
    /**
     * Get a value for a key
     * @memberof StorageInterface
     */
    getValue(name: string): Promise<string | null>;
    /**
     * Remove a value for a key
     * @memberof StorageInterface
     */
    removeKey(name: string): Promise<void>;
    /**
     * Set a value for a key
     * @memberof StorageInterface
     */
    setValue(name: string, value: string): Promise<void>;
}
