import { Entry } from "../core/Entry.js";
import { GroupID } from "../types.js";
export declare enum EntryURLType {
    Any = "any",
    General = "general",
    Icon = "icon",
    Login = "login"
}
export declare function getEntryPath(entry: Entry): Array<GroupID>;
/**
 * Get URLs from an entry's properties
 * Allows for preferential sorting
 * @param properties The entry properties
 * @param preference Optional URL type preference
 */
export declare function getEntryURLs(properties: {
    [key: string]: string;
}, preference?: EntryURLType): Array<string>;
