import { Group } from "../core/Group.js";
import { Vault } from "../core/Vault.js";
import { History } from "../types.js";
export declare function mergeHistories(initial: any, incoming: any): any[];
/**
 * Move a group between archives
 * @param movingGroup The group to move
 * @param targetGroup The group to move to
 * @throws {Error} Throws if the remote type is not recognised
 */
export declare function moveGroupBetweenVaults(movingGroup: Group, targetGroup: Group | Vault): void;
/**
 * Prepend the share prefix to every line that doesn't have it
 * @param history Array of history lines
 * @returns Prefixed history lines
 */
export declare function prependSharePrefix(history: History, shareID: string): History;
/**
 * Remove the share prefix to every line that has it
 * @param history Array of history lines
 * @returns Non-prefixed history lines
 */
export declare function removeSharePrefix(history: History): History;
